/* Problem URL: https://codeforces.com/gym/104114/problem/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vvl fds(n, vl(n));
    cin >> fds;

    V<tuple<ll, int, int>> edges;
    rep(i, n) {
        nrep(j, i + 1, n) {
            edges.emplace_back(fds[i][j], i, j);
        }
    }

    sort(all(edges), greater<>());

    vi dsu(n);
    rep(i, n) {
        dsu[i] = i;
    }

    function<int(int)> find_p = [&](int i) {
        if (dsu[i] == i) {
            return i;
        }
        return dsu[i] = find_p(dsu[i]);
    };

    auto join = [&](int a, int b) {
        a = find_p(a);
        b = find_p(b);

        if (b < a) {
            swap(a, b);
        }

        dsu[b] = a;
        return a != b;
    };

    ll ans = 0;
    V<pair<int, int>> aedg;
    for (auto [c, u, v] : edges) {
        v = find_p(v);
        u = find_p(u);
        if (join(u, v)) {
            ans += c;
            aedg.emplace_back(u, v);
        }
    }

    cout << ans << '\n';
    for (auto [u, v] : aedg) {
        cout << u + 1 << ' ' << v + 1 << '\n';
    }
}
